/**********************************************************************
 * Programaci�n Concurrente Y Distribuida
 * Ingenier�a Inform�tica
 * 
 * Proyecto: Red Ferroviaria (Secuencial)
 * 
 * Fichero: Clase RedFerroviaria
 * 
 * Autor: J.M. Drake y L. Barros
 * Fecha: 31-09-09
 * 
 *********************************************************************/
public class ProgramaPrincipal {
	 /**
	 * Definici�n de constantes
	 */
	final static long TIEMPO_DE_EJECUCION_MS=60000L;
  	final static int TIEMPO_ACTUALIZACION_MS=200;
  	final static long PORCENTAJE= 20000L;
  	
	/**
  	 * Arrays que contienen las instancias de los trenes que circulan por 
  	 * el tramo ferroviario 
  	 */  	
  	public static  Tren listaTrenesRojos[];
	public static  Tren listaTrenesAzules[];	
  
	public static void main(String[] args) {			
		RedFerroviaria laRed =new RedFerroviaria();		 
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e1) {}	
		/**
		 * Lista que contiene las instancia de los trenes que circulan por el
		 * tramo ferroviario.
		 */		
		listaTrenesRojos=new Tren[RedFerroviaria.numMaxTrenesPorTramo()];
		listaTrenesAzules=new Tren[RedFerroviaria.numMaxTrenesPorTramo()];

		for (int i=0;i<RedFerroviaria.numMaxTrenesPorTramo();i++){
			listaTrenesAzules[i]=new Tren(TramoFerroviario.Tramos.TRAMO_AZUL,laRed,10);			
			listaTrenesRojos[i]=new Tren(TramoFerroviario.Tramos.TRAMO_ROJO,laRed,10);			
		}		 

		try {
			Thread.sleep(TIEMPO_DE_EJECUCION_MS);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		System.out.println("SE AVISA A LOS TRENES");
		for (int i=0;i<RedFerroviaria.numMaxTrenesPorTramo();i++){
			listaTrenesRojos[i].termina();			 
			listaTrenesAzules[i].termina();			 
		}
		
		for (int i=0;i<RedFerroviaria.numMaxTrenesPorTramo();i++){
			try {
				listaTrenesRojos[i].join();
				listaTrenesAzules[i].join();			 
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			 
		}
		
		System.out.println("Los threads de trenes han terminado");
		
	}
}
